unit PlannerRole;
{
  Zdroje v kalendroch nepouvam
  Tu nevidm, eby mali nejak vznam
  Ak sa to v budcnosti zmen, nech si to tu niekto urob
}
interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes, System.Generics.Collections,
  Vcl.Menus, Vcl.ComCtrls, Vcl.ExtCtrls, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Mask,
  Vcl.Buttons,
  Data.DB, Data.Win.ADODB,
  AdvPanel, AdvStyleIF, AdvCombo, AdvAppStyler, AdvOfficePager, AdvSpin, AdvDropDown, AdvSmoothEdit, AeroButtons,
  AdvSmoothEditButton, AdvSmoothDatePicker,
  Planner, DBPlanner, PlannerMonthView, DBPlannerMonthView,
  uPlannerRole;

type
  TViews = (vwMultiDay, vwPeriod, vwHalfDayPeriod, vwMonth, vwMultiMonth, vwTimeLine, vwActiveDay, vwActiveDayPeriod);
  TPage = (pgDay, pgWeek, pgMonth);

  TfrmPlannerRole = class(TForm)
    advcbxSelectStatrtDayMonth: TAdvComboBox;
    advcbxViews: TAdvComboBox;
    advpgeDay: TAdvOfficePage;
    advpgeMonth: TAdvOfficePage;
    advpgeWeek: TAdvOfficePage;
    advsedDayIncrementMultiDay: TAdvSpinEdit;
    advsedMonthIncrementMultiMonth: TAdvSpinEdit;
    advsedMonthOfMonthMultiMonth: TAdvSpinEdit;
    advsedNumberOfDayActiveDay: TAdvSpinEdit;
    advsedNumberOfDayMultiDay: TAdvSpinEdit;
    advsedNumberOfWeekWeek: TAdvSpinEdit;
    advsedRowHeightPeriod: TAdvSpinEdit;
    advsedStartWeekWeek: TAdvSpinEdit;
    advsedYearMonth: TAdvSpinEdit;
    advsedYearMultiMonth: TAdvSpinEdit;
    advsedYearWeek: TAdvSpinEdit;
    dbacdyprsrActiveDayPeriod: TDBActiveDayPeriodSource;
    dbacdysrActiveDay: TDBActiveDaySource;
    dbdysrMultiDay: TDBDaySource;
    dbhldyprsrHalfDayPeriod: TDBHalfDayPeriodSource;
    dbmlmnsrMultiMonth: TDBMultiMonthSource;
    dbmnsrMonth: TDBMonthSource;
    dbplDay: TDBPlanner;
    dbplWeek: TDBPlanner;
    dbpmwMonth: TDBPlannerMonthView;
    dbprsrPeriod: TDBPeriodSource;
    dbtmlnsrTimeLine: TDBTimeLineSource;
    dbwksrWeek: TDBWeekSource;
    frmstlrPlannerRole: TAdvFormStyler;
    jstpnlActiveDay: TAdvPanel;
    jstpnlActiveDayPeriod: TAdvPanel;
    jstpnlAdvOfficePager: TAdvPanel;
    jstpnlDayOptionsBasic: TAdvPanel;
    jstpnlHalfDayPeriod: TAdvPanel;
    jstpnljstpnlDayOptions: TAdvPanel;
    jstpnlMonth: TAdvPanel;
    jstpnlMonthProperty: TAdvPanel;
    jstpnlMultiDay: TAdvPanel;
    jstpnlMultiMonth: TAdvPanel;
    jstpnlPeriod: TAdvPanel;
    jstpnlProperyTop: TAdvPanel;
    jstpnlTimeLine: TAdvPanel;
    jstpnlWeekProperties: TAdvPanel;
    lblActiveDay: TLabel;
    lblActiveDayPeriod: TLabel;
    lblHalfDayPeriod: TLabel;
    lblMonth: TLabel;
    lblMultiDay: TLabel;
    lblMultiMonth: TLabel;
    lblPeriod: TLabel;
    lblTimeLine: TLabel;
    lblWeek: TLabel;
    offpgrPlanner: TAdvOfficePager;
    smdtpkDayActiveDay: TAdvSmoothDatePicker;
    smdtpkDayMultiDay: TAdvSmoothDatePicker;
    advcbxStartMonthMultiMonth: TAdvComboBox;
    advcbxMonthMonth: TAdvComboBox;
    advcbxMonthWeek: TAdvComboBox;
    ds1: TDataSource;
    tblAdo: TADOTable;
    atncfldAdoIDSCHEDULE: TAutoIncField;
    dtmfldAdoSTARTTIME: TDateTimeField;
    dtmfldAdoENDTIME: TDateTimeField;
    wdstrngfldAdoSUBJECT: TWideStringField;
    wdstrngfldAdoNOTES: TWideStringField;
    intgrfldAdoCOLOR: TIntegerField;
    intgrfldAdoIMAGE: TIntegerField;
    blnfldAdoCAPTION: TBooleanField;
    wdstrngfldAdoRECURRENCY: TWideStringField;
    intgrfldAdoRESOURCE: TIntegerField;
    dtmfldAdoMINTIME: TDateTimeField;
    dtmfldAdoMAXTIME: TDateTimeField;
    intgrfldAdoSHAPE: TIntegerField;
    procedure FormCreate(Sender: TObject);
    procedure advcbxViewsChange(Sender: TObject);
    procedure dbpmwMonthFieldsToItem(Sender: TObject; Fields: TFields; Item: TPlannerItem);
    procedure dbpmwMonthItemToFields(Sender: TObject; Fields: TFields; Item: TPlannerItem);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure offpgrPlannerChange(Sender: TObject);
    procedure offpgrPlannerChanging(Sender: TObject; FromPage, ToPage: Integer; var AllowChange: Boolean);
  strict private
  const
    Shift = 10;
    DisplayEnd = 1;
    ActiveStart = 2;
    ActiveEnd = 3;
    Header = 'Check dates';
    Footer = 'Time line';
  var
    FRolePlanner: TRolePlanner;
    procedure GetItemSource;
  strict protected
    procedure CreateObjects;
    procedure SetForm;
  end;

var
  frmPlannerRole: TfrmPlannerRole;

implementation

{$R *.dfm}

procedure TfrmPlannerRole.FormCreate(Sender: TObject);
begin
  SetForm;
end;

procedure TfrmPlannerRole.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FRolePlanner);
end;

procedure TfrmPlannerRole.GetItemSource;
begin
  case TViews(advcbxViews.ItemIndex) of
    vwMultiDay: dbplDay.ItemSource := dbdysrMultiDay;
    vwPeriod: dbplDay.ItemSource := dbprsrPeriod;
    vwHalfDayPeriod: dbplDay.ItemSource := dbhldyprsrHalfDayPeriod;
    vwMonth: dbplDay.ItemSource := dbmnsrMonth;
    vwMultiMonth: dbplDay.ItemSource := dbmlmnsrMultiMonth;
    vwTimeLine: dbplDay.ItemSource := dbtmlnsrTimeLine;
    vwActiveDay: dbplDay.ItemSource := dbacdysrActiveDay;
    vwActiveDayPeriod: dbplDay.ItemSource := dbacdyprsrActiveDayPeriod;
  end;
end;

procedure TfrmPlannerRole.advcbxViewsChange(Sender: TObject);
begin
  GetItemSource;
  FRolePlanner.SetPlannerProperies;
end;

procedure TfrmPlannerRole.CreateObjects;
begin
  FRolePlanner := TRolePlanner.CreateForm(Self, ds1);
end;

procedure TfrmPlannerRole.dbpmwMonthFieldsToItem(Sender: TObject; Fields: TFields; Item: TPlannerItem);
begin
  if not tblAdo.FieldByName('COLOR').IsNull then
  begin
    Item.Color := TColor(tblAdo.FieldByName('COLOR').AsInteger);
    Item.ColorTo := Item.Color;
    Item.CaptionBkg := Item.Color;
  end;

  if tblAdo.FieldByName('SHAPE').AsInteger < Shift then
  begin
    Item.DrawTool := nil;
    Item.Shape := TPlannerShape(tblAdo.FieldByName('SHAPE').AsInteger);
    Item.Tag := -1;
  end
  else
  begin
    Item.DrawTool := FRolePlanner.ShapeDrawTool[tblAdo.FieldByName('SHAPE').AsInteger - Shift];
    Item.Shape := psTool;
    Item.Tag := tblAdo.FieldByName('SHAPE').AsInteger - Shift;
  end;

  Item.ImageID := Fields.FieldByName('IMAGE').AsInteger;
end;

procedure TfrmPlannerRole.dbpmwMonthItemToFields(Sender: TObject; Fields: TFields; Item: TPlannerItem);
begin
  if Item.DBKey = '' then
  begin
    Fields.FieldByName('SUBJECT').AsString := 'Neuren predmet';
  end;

  Fields.FieldByName('IDSCHEDULE').AsInteger := StrToInt(Item.DBKey);
  Fields.FieldByName('COLOR').AsInteger := Item.Color;
  Fields.FieldByName('IMAGE').AsInteger := Item.ImageID;

  if Item.Tag > -1 then
    Fields.FieldByName('SHAPE').AsInteger := Item.Tag + Shift
  else
    Fields.FieldByName('SHAPE').AsInteger := Ord(TPlannerShape(Item.Shape));
end;

procedure TfrmPlannerRole.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmPlannerRole.offpgrPlannerChange(Sender: TObject);
begin
  case TPage(offpgrPlanner.ActivePageIndex) of
    pgDay: advcbxViews.OnChange(advcbxViews);
    pgWeek:
    begin
      if dbwksrWeek.Month <> advcbxMonthWeek.ItemIndex + 1 then
        dbwksrWeek.Month := advcbxMonthWeek.ItemIndex + 1;

      if dbwksrWeek.Year <> advsedYearWeek.Value then
        dbwksrWeek.Year := advsedYearWeek.Value;

      tblAdo.Refresh;
      dbplWeek.Update;
    end;
    pgMonth:
    begin
      tblAdo.Refresh;
      dbpmwMonth.Update;
    end;
  end;
end;

procedure TfrmPlannerRole.offpgrPlannerChanging(Sender: TObject; FromPage, ToPage: Integer; var AllowChange: Boolean);
begin
  AllowChange := False;
end;

procedure TfrmPlannerRole.SetForm;
begin
  CreateObjects;
  inherited;
  tblAdo.Active := True;
  advcbxViews.OnChange(advcbxViews);
  dbpmwMonth.Month := 1;
  dbplDay.ItemSource.Active := False;
  dbplDay.ItemSource.Active := True;  // FI:W508
  dbplWeek.ItemSource.Active := False;
  dbplWeek.ItemSource.Active := True;  // FI:W508
  dbpmwMonth.Update;
end;

end.
